#include <stddef.h>
#include <stdio.h>

#define L1 1
#define L2 2
#define L3 3
#define L4 4
#define C1 5
#define C2 6
#define C3 7
#define C4 8

void set_pin(int id, short state, size_t *row, size_t *col, char *sequence,
             size_t *pointer);

static char *sequence;
static size_t *pointer;
static size_t row_main = 0;
static size_t col_main = 0;

void set_number(char nb)
{
    const char keyboard[4][4] = {
        { '1', '2', '3', 'A' },
        { '4', '5', '6', 'B' },
        { '7', '8', '9', 'C' },
        { '*', '0', '#', 'D' },
    };

    int row = 0;
    int col = 0;
    int found = 0;
    for (; !found && row < 4; row++)
    {
        col = 0;
        for (; !found && col < 4; col++)
        {
            if (keyboard[row][col] == nb)
            {
                found = 1;
                row--;
                col--;
            }
        }
    }

    int pins[8] = { L1, L2, L3, L4, C1, C2, C3, C4 };
    set_pin(pins[4 + col], 1, &row_main, &col_main, sequence, pointer);
    set_pin(pins[row], 1, &row_main, &col_main, sequence, pointer);
}

void reset_all_pin()
{
    int pins[8] = { L1, L2, L3, L4, C1, C2, C3, C4 };
    for (size_t i = 0; i < 8; i++)
    {
        set_pin(pins[i], 0, &row_main, &col_main, sequence, pointer);
    }
}

void student(char *seq, size_t *ptr)
{
    sequence = seq;
    pointer = ptr;
    int nb = 1000;
    int max_nb = 9999;
    while (1)
    {
        if (nb <= max_nb)
        {
            int tmp_nb = nb;
            char nbs[4];
            int place = 3;

            while (tmp_nb > 0)
            {
                nbs[place] = '0' + (tmp_nb % 10);
                tmp_nb /= 10;
                place--;
            }

            for (size_t i = 0; i < 4; i++)
            {
                reset_all_pin();
                set_number(nbs[i]);
            }
            reset_all_pin();
            set_number('#');
            nb++;
        }
    }
}